function continuation(up)

close all


high_limit=2750; %plotting values for corrected data
low_limit=-4500;


load 'reduced.mat'; % IBA - grid of data already reduced to the pole and diurnally corrected (no linear trend) 
                %linx
                %liny
                
                
% load 'corr.mat';% First column time
%                  % second column northing
%                 % third column easting
%                 % 4th column nT
I=75;
D=50;
i=sqrt(-1);

nx=256;
ny=nx;
% 
% linx(1,:)=linspace(min(cor(:,3)),max(cor(:,3)),nx);
% liny(:,1)=linspace(min(cor(:,2)),max(cor(:,2)),ny);
% 
% IBA=griddata(cor(:,3),cor(:,2),cor(:,4),linx,liny,'v4');
IBA=filtR_dat;

dx=mean(diff(linx));
dy=mean(diff(liny));

nyqx=(1/(2*dx));
nyqy=(1/(2*dy));

kx=linspace(-nyqx,nyqx,nx);
ky=linspace(-nyqy,nyqy,ny);

L=cos(I)*cos(D);
l=cos(I)*cos(D);
R=cos(I)*sin(D);
r=cos(I)*sin(D);
Q=sin(I);
q=sin(I);


[KX KY]=meshgrid(kx,ky);
Kx=KX.*KX;
Ky=KY.*KY;

% for m= 1:nx
%     for n= 1:ny
%         RTP(m,n)=(Kx(m,n)+Ky(m,n))/(( (i*L*KX(m,n)) + (i*R*KY(m,n)) + (Q*((Kx(m,n)+Ky(m,n)).^0.5))) .* ( (i*l*KX(m,n)) + (i*r*KY(m,n)) + (q*((Kx(m,n)+Ky(m,n)).^0.5)) ));
%     end
% end
% 
% RTP=fftshift(RTP);
% 
% IBA=real(ifft2(fft2(IBA).*RTP));
% 
% save('RTP.mat','IBA','linx','liny')


% UPWARD CONTINUATION  **************************************************

%first with an upward depth of num m, and a downward depth of num m 
filt_up=zeros(nx,ny);
filt_down=zeros(nx,ny);
for i=1:nx
    for j=1:ny
        filt_up(i,j)=exp((-1*up).*(((kx(1,i).^2)+(ky(1,j).^2)).^0.5));
        filt_down(i,j)=exp(up.*(((kx(1,i).^2)+(ky(1,j).^2)).^0.5));
    end
end

g_up=real(ifft2(fft2(IBA).*fftshift(filt_up)));
g_down=real(ifft2(fft2(IBA).*fftshift(filt_down)));

figure
pcolor(linx,liny,IBA)
title('Quad data')
colorbar;
caxis([low_limit,high_limit])
set(get(colorbar,'ylabel'),'string','nT')
xlabel('Easting (m)')
ylabel('Northing (m)')
shading interp;
shading flat;

asBA=abs(fftshift(fft2(g_down)));


figure
pcolor(linx,liny,g_up)
colorbar;
caxis([low_limit,high_limit])
set(get(colorbar,'ylabel'),'string','nT')
shading interp;
shading flat;
title('Upward continuation of Data')
xlabel('Easting (m)')
ylabel('Northing (m)')


asBA=abs(fftshift(fft2(g_down)));


figure
pcolor(linx,liny,g_down)
colorbar;
caxis([low_limit,high_limit])
set(get(colorbar,'ylabel'),'string','nT')
shading interp;
shading flat;
title('Downward continuation of Data')
xlabel('Easting (m)')
ylabel('Northing (m)')

